```{include} ../../README.md
:relative-docs: docs/source/
:relative-images:
```

```{toctree}
:hidden:

API <api>
```

```{toctree}
:caption: Concepts
:hidden:

Commands <command>
Args <arg>
Subcommands <subcommand>
Invoke <invoke>
Annotations <annotation>
Parse Vs Invoke <parse_vs_invoke>
```

```{toctree}
:caption: Details
:hidden:

vs Click / Typer / Argparse <comparison>
Dataclasses/Pydantic/Attrs <class_compatibility>
Rich Integration <rich>
Completions <completion>
Output, Exiting, and Exit Codes <exiting>
Parser Backends (Cappa/Argparse) <backends>
Testing <testing>
Function/Method Based Commands <functions_and_methods>
```

```{toctree}
:caption: Extra Details
:hidden:

Examples (vs click/typer/argparse) <examples/index>
Help/Help Inference <help>
Asyncio <asyncio>
Manual Construction <manual_construction>
Sphinx/Docutils Directive <sphinx>
Shared State <state>
```

```{toctree}
:caption: Useful Links
:hidden:

GitHub Repository <https://github.com/dancardin/cappa>
PyPI <https://pypi.org/project/cappa>
Changelog <changelog>
```
